package com.hai.dao;

import com.hai.entity.HighChildOrder;
import com.hai.entity.HighChildOrderExample.Criteria;
import com.hai.entity.HighChildOrderExample.Criterion;
import com.hai.entity.HighChildOrderExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighChildOrderSqlProvider {

    public String countByExample(HighChildOrderExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_child_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighChildOrderExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_child_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighChildOrder record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_child_order");
        
        if (record.getOrderId() != null) {
            sql.VALUES("order_id", "#{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getMemId() != null) {
            sql.VALUES("mem_id", "#{memId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsType() != null) {
            sql.VALUES("goods_type", "#{goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.VALUES("goods_id", "#{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.VALUES("goods_name", "#{goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsImg() != null) {
            sql.VALUES("goods_img", "#{goodsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsSpecName() != null) {
            sql.VALUES("goods_spec_name", "#{goodsSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsPrice() != null) {
            sql.VALUES("goods_price", "#{goodsPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsActualPrice() != null) {
            sql.VALUES("goods_actual_price", "#{goodsActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleCount() != null) {
            sql.VALUES("sale_count", "#{saleCount,jdbcType=INTEGER}");
        }
        
        if (record.getTotalPrice() != null) {
            sql.VALUES("total_price", "#{totalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGiveawayType() != null) {
            sql.VALUES("giveaway_type", "#{giveawayType,jdbcType=BIT}");
        }
        
        if (record.getChildOrdeStatus() != null) {
            sql.VALUES("child_orde_status", "#{childOrdeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPraiseStatus() != null) {
            sql.VALUES("praise_status", "#{praiseStatus,jdbcType=INTEGER}");
        }
        
        if (record.getGasOilNo() != null) {
            sql.VALUES("gas_oil_no", "#{gasOilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasGunNo() != null) {
            sql.VALUES("gas_gun_no", "#{gasGunNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasOilType() != null) {
            sql.VALUES("gas_oil_type", "#{gasOilType,jdbcType=INTEGER}");
        }
        
        if (record.getGasOrderNo() != null) {
            sql.VALUES("gas_order_no", "#{gasOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasPriceGun() != null) {
            sql.VALUES("gas_price_gun", "#{gasPriceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceVip() != null) {
            sql.VALUES("gas_price_vip", "#{gasPriceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighChildOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_id");
        sql.SELECT("mem_id");
        sql.SELECT("goods_type");
        sql.SELECT("goods_id");
        sql.SELECT("goods_name");
        sql.SELECT("goods_img");
        sql.SELECT("goods_spec_name");
        sql.SELECT("goods_price");
        sql.SELECT("goods_actual_price");
        sql.SELECT("sale_count");
        sql.SELECT("total_price");
        sql.SELECT("giveaway_type");
        sql.SELECT("child_orde_status");
        sql.SELECT("praise_status");
        sql.SELECT("gas_oil_no");
        sql.SELECT("gas_gun_no");
        sql.SELECT("gas_oil_type");
        sql.SELECT("gas_order_no");
        sql.SELECT("gas_price_gun");
        sql.SELECT("gas_price_vip");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_child_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighChildOrder record = (HighChildOrder) parameter.get("record");
        HighChildOrderExample example = (HighChildOrderExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_child_order");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        }
        
        if (record.getMemId() != null) {
            sql.SET("mem_id = #{record.memId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{record.goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.SET("goods_name = #{record.goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsImg() != null) {
            sql.SET("goods_img = #{record.goodsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsSpecName() != null) {
            sql.SET("goods_spec_name = #{record.goodsSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsPrice() != null) {
            sql.SET("goods_price = #{record.goodsPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsActualPrice() != null) {
            sql.SET("goods_actual_price = #{record.goodsActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleCount() != null) {
            sql.SET("sale_count = #{record.saleCount,jdbcType=INTEGER}");
        }
        
        if (record.getTotalPrice() != null) {
            sql.SET("total_price = #{record.totalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGiveawayType() != null) {
            sql.SET("giveaway_type = #{record.giveawayType,jdbcType=BIT}");
        }
        
        if (record.getChildOrdeStatus() != null) {
            sql.SET("child_orde_status = #{record.childOrdeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPraiseStatus() != null) {
            sql.SET("praise_status = #{record.praiseStatus,jdbcType=INTEGER}");
        }
        
        if (record.getGasOilNo() != null) {
            sql.SET("gas_oil_no = #{record.gasOilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasGunNo() != null) {
            sql.SET("gas_gun_no = #{record.gasGunNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasOilType() != null) {
            sql.SET("gas_oil_type = #{record.gasOilType,jdbcType=INTEGER}");
        }
        
        if (record.getGasOrderNo() != null) {
            sql.SET("gas_order_no = #{record.gasOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasPriceGun() != null) {
            sql.SET("gas_price_gun = #{record.gasPriceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceVip() != null) {
            sql.SET("gas_price_vip = #{record.gasPriceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_child_order");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        sql.SET("mem_id = #{record.memId,jdbcType=BIGINT}");
        sql.SET("goods_type = #{record.goodsType,jdbcType=INTEGER}");
        sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        sql.SET("goods_name = #{record.goodsName,jdbcType=VARCHAR}");
        sql.SET("goods_img = #{record.goodsImg,jdbcType=VARCHAR}");
        sql.SET("goods_spec_name = #{record.goodsSpecName,jdbcType=VARCHAR}");
        sql.SET("goods_price = #{record.goodsPrice,jdbcType=DECIMAL}");
        sql.SET("goods_actual_price = #{record.goodsActualPrice,jdbcType=DECIMAL}");
        sql.SET("sale_count = #{record.saleCount,jdbcType=INTEGER}");
        sql.SET("total_price = #{record.totalPrice,jdbcType=DECIMAL}");
        sql.SET("giveaway_type = #{record.giveawayType,jdbcType=BIT}");
        sql.SET("child_orde_status = #{record.childOrdeStatus,jdbcType=INTEGER}");
        sql.SET("praise_status = #{record.praiseStatus,jdbcType=INTEGER}");
        sql.SET("gas_oil_no = #{record.gasOilNo,jdbcType=VARCHAR}");
        sql.SET("gas_gun_no = #{record.gasGunNo,jdbcType=VARCHAR}");
        sql.SET("gas_oil_type = #{record.gasOilType,jdbcType=INTEGER}");
        sql.SET("gas_order_no = #{record.gasOrderNo,jdbcType=VARCHAR}");
        sql.SET("gas_price_gun = #{record.gasPriceGun,jdbcType=DECIMAL}");
        sql.SET("gas_price_vip = #{record.gasPriceVip,jdbcType=DECIMAL}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighChildOrderExample example = (HighChildOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighChildOrder record) {
        SQL sql = new SQL();
        sql.UPDATE("high_child_order");
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getMemId() != null) {
            sql.SET("mem_id = #{memId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.SET("goods_name = #{goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsImg() != null) {
            sql.SET("goods_img = #{goodsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsSpecName() != null) {
            sql.SET("goods_spec_name = #{goodsSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsPrice() != null) {
            sql.SET("goods_price = #{goodsPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsActualPrice() != null) {
            sql.SET("goods_actual_price = #{goodsActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleCount() != null) {
            sql.SET("sale_count = #{saleCount,jdbcType=INTEGER}");
        }
        
        if (record.getTotalPrice() != null) {
            sql.SET("total_price = #{totalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGiveawayType() != null) {
            sql.SET("giveaway_type = #{giveawayType,jdbcType=BIT}");
        }
        
        if (record.getChildOrdeStatus() != null) {
            sql.SET("child_orde_status = #{childOrdeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPraiseStatus() != null) {
            sql.SET("praise_status = #{praiseStatus,jdbcType=INTEGER}");
        }
        
        if (record.getGasOilNo() != null) {
            sql.SET("gas_oil_no = #{gasOilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasGunNo() != null) {
            sql.SET("gas_gun_no = #{gasGunNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasOilType() != null) {
            sql.SET("gas_oil_type = #{gasOilType,jdbcType=INTEGER}");
        }
        
        if (record.getGasOrderNo() != null) {
            sql.SET("gas_order_no = #{gasOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGasPriceGun() != null) {
            sql.SET("gas_price_gun = #{gasPriceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getGasPriceVip() != null) {
            sql.SET("gas_price_vip = #{gasPriceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighChildOrderExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}